/**************************************************************************
 * DO NOT USE ANY OF THIS! IT IS STRICTLY TEMPORARY AND WILL GO AWAY!     *
 **************************************************************************/
#define USE_DIRECT_ACCESS 1

#if USE_DIRECT_ACCESS && defined NATMEM_OFFSET

#define debug(x) // x
#define idebug(x) // x

#include <assert.h>
#include <asm/io.h>
#include "direct_access_irq.h"
#include "custom.h" /* For INTREQ */

static uae_u32 direct_mem_lget (uaecptr) REGPARAM;
static uae_u32 direct_mem_wget (uaecptr) REGPARAM;
static uae_u32 direct_mem_bget (uaecptr) REGPARAM;
static void direct_mem_lput (uaecptr, uae_u32) REGPARAM;
static void direct_mem_wput (uaecptr, uae_u32) REGPARAM;
static void direct_mem_bput (uaecptr, uae_u32) REGPARAM;
static int direct_mem_check (uaecptr addr, uae_u32 size) REGPARAM;
static uae_u8* direct_mem_xlate (uaecptr addr) REGPARAM;

#define NUM_XINT 16
#define NUM_AINT 15
#define SIGBASE 32

unsigned long oinkteatime;
extern unsigned long foink,foink3;


static int intnum[NUM_XINT];
static int apend[NUM_AINT];
static int pending=0;

unsigned long oinkpend=0;

static __inline__ void inc_pend(int n)
{
    apend[n]++;
    pending++;
    if (!oinkpend)
	oinkpend=read_processor_time();
}


static __inline__ void trigger_aint(int n)
{
	idebug(write_log("Trigger Amiga interrupt %d\n",ai));
	INTREQ(0x8000 | (1<<n));
	oinkteatime=read_processor_time();
}

void da_deliver_pend(void)
{
    unsigned long now=read_processor_time();

    if (pending) {
	int n=NUM_AINT;
	while (n--) {
	    if (apend[n] && (intreq & (1<<n))==0) {
		trigger_aint(n);
		pending--;
		apend[n]--;
		foink++;
		oinkpend-=now;
		write_log("Deliver interrupt %lu cycles late\n",-oinkpend);
		oinkpend=0;
		break;
	    }
	}
    }
}

    
static void x86_interrupt(int signum)
{
    int irq=signum-SIGBASE;
    int ai;
    static unsigned long last_check=0;
    unsigned long now=read_processor_time();

    foink3++;
    idebug(write_log("Received signal %d (IRQ %d)\n",signum,irq));
    ai=intnum[irq];
    if (ai>=0) {
	if (intreq & (1<<ai)) {
	    // write_log("Interrupt was already active!\n");
	    inc_pend(ai);
	}
	else
	    trigger_aint(ai);
    }
    else {
	write_log("Received x86 interrupt %d, not handled!\n",irq);
    }
#if 0
    if (last_check) {
	write_log("Cycles since last check: %lu\n",now-last_check);
    }
    last_check=now;
#endif
}

static uae_u32 REGPARAM2 direct_mem_lget(uaecptr addr)
{
    uae_u32 *m;
    
    assert(canbang);
    m = (uae_u32 *)(NATMEM_OFFSET + (uae_u32)addr);

    return (do_get_mem_long (m));
}

static uae_u32 REGPARAM2 direct_mem_wget(uaecptr addr)
{
    uae_u16 *m;

    assert(canbang);
    m = (uae_u16 *)(NATMEM_OFFSET + (uae_u32)addr);

    return (do_get_mem_word (m));
}

static uae_u32 REGPARAM2 direct_mem_bget(uaecptr addr)
{
    uae_u8* m;

    assert(canbang);
    m = (uae_u8 *)(NATMEM_OFFSET + (uae_u32)addr);

    return *m;
}

static void REGPARAM2 direct_mem_lput(uaecptr addr, uae_u32 l)
{
    uae_u32 *m;

    assert(canbang);
    m = (uae_u32 *)(NATMEM_OFFSET + (uae_u32)addr);
    do_put_mem_long (m, l);
}

static void REGPARAM2 direct_mem_wput(uaecptr addr, uae_u32 w)
{
    uae_u16 *m;

    assert(canbang);
    m = (uae_u16 *)(NATMEM_OFFSET + (uae_u32)addr);
    do_put_mem_word (m, w);
}

static void REGPARAM2 direct_mem_bput(uaecptr addr, uae_u32 b)
{
    uae_u8* m;

    assert(canbang);
    m = (uae_u8 *)(NATMEM_OFFSET + (uae_u32)addr);
    *m = b;
}

static int REGPARAM2 direct_mem_check(uaecptr addr, uae_u32 size)
{
    return 1;
}

static uae_u8 REGPARAM2 * direct_mem_xlate(uaecptr addr)
{
    return (uae_u8*)((uae_u32)addr+NATMEM_OFFSET);
}


addrbank direct_mem_bank= {
    direct_mem_lget, direct_mem_wget, direct_mem_bget,
    direct_mem_lput, direct_mem_wput, direct_mem_bput,
    direct_mem_xlate, direct_mem_check, NULL
};

static uae_u32 direct_io_lget(uaecptr) REGPARAM;
static uae_u32 direct_io_wget(uaecptr) REGPARAM;
static uae_u32 direct_io_bget(uaecptr) REGPARAM;
static void direct_io_lput(uaecptr, uae_u32) REGPARAM;
static void direct_io_wput(uaecptr, uae_u32) REGPARAM;
static void direct_io_bput(uaecptr, uae_u32) REGPARAM;
static int direct_io_check(uaecptr addr, uae_u32 size) REGPARAM;

#define DIRECT_IO_MASK 0xffff

#define direct_inl(x) inl(x)
#define direct_inw(x) inw(x)
#define direct_inb(x) inb(x)

#define direct_outl(x,y) outl(x,y)
#define direct_outw(x,y) outw(x,y)
#define direct_outb(x,y) outb(x,y)

static uae_u32 REGPARAM2 direct_io_lget(uaecptr addr)
{
    uae_u32 *m;
    uae_u32 l;

    special_mem|=S_READ;

    addr &= DIRECT_IO_MASK;
    l=direct_inl(addr);

    debug(write_log("direct_io_lget(%x)=%x\n",addr,l));
    return l;
}

static uae_u32 REGPARAM2 direct_io_wget(uaecptr addr)
{
    uae_u16 *m;
    uae_u16 w;

    special_mem|=S_READ;

    addr &= DIRECT_IO_MASK;
    w=direct_inw(addr);

    debug(write_log("direct_io_wget(%x)=%x\n",addr,w));
    return w;
}

static uae_u32 REGPARAM2 direct_io_bget(uaecptr addr)
{
    uae_u8 b;

    special_mem|=S_READ;

    addr &= DIRECT_IO_MASK;
    b=direct_inb(addr);

    debug(write_log("direct_io_bget(%x)=%x\n",addr,b));
    return b;
}

void REGPARAM2 direct_io_lput(uaecptr addr, uae_u32 l)
{
    uae_u32 *m;

    special_mem|=S_WRITE;

    addr &= DIRECT_IO_MASK;

    debug(write_log("direct_io_lput(%x,%x)\n",addr,l));
    direct_outl(l,addr);
}

void REGPARAM2 direct_io_wput(uaecptr addr, uae_u32 w)
{
    uae_u16 *m;

    special_mem|=S_WRITE;

    addr &= DIRECT_IO_MASK;
    debug(write_log("direct_io_wput(%x,%x)\n",addr,w));
    direct_outw(w,addr);
}

void REGPARAM2 direct_io_bput(uaecptr addr, uae_u32 b)
{
    special_mem|=S_WRITE;

    addr &= DIRECT_IO_MASK;
    debug(write_log("direct_io_bput(%x,%x)\n",addr,b));
    direct_outb(b,addr);
}

int REGPARAM2 direct_io_check(uaecptr addr, uae_u32 size)
{
    return 0;
}

addrbank direct_io_bank= {
    direct_io_lget, direct_io_wget, direct_io_bget,
    direct_io_lput, direct_io_wput, direct_io_bput,
    default_xlate, direct_io_check, NULL
};

static void direct_access_reset(void)
{
    return;
}

static void direct_access_install(void)
{
    FILE* conf;

    int i;

    for (i=0;i<NUM_XINT;i++)
	intnum[i]=-1;

    conf=fopen("/tmp/direct_access","r");
    if (!conf) {
	write_log("DA: Failed setting up direct access --- no /tmp/direct_access\n");
	return;
    }
    write_log("DA: Start setting up direct access\n");
    while (!feof(conf)) {
	char line[1000];
	
	if (fgets(line,1000,conf)) {
	    unsigned int nbase;
	    unsigned int size;
	    unsigned int base;
	    unsigned int xint;
	    unsigned int aint;
	    void* result;
	    int mem;

	    switch(line[0]) {
	     case 'i':
		if (sscanf(line+1,"%x",&base)!=1) {
		    write_log("DA: Can't understand direct access line:\n   %s\n",
			      line);
		    break;
		}
		if (iopl(3)) {
		    write_log("DA: Could not enable direct I/O access, iopl(3) failed!\n");
		    abort();
		}		    
		map_banks(&direct_io_bank,base>>16,1,0);
		write_log("DA: Mapped native IO at 68k address 0x%08x\n",base);
		break;
	     case 'm':
		if (sscanf(line+1,"%x:%d=%x",&nbase,&size,&base)!=3) {
		    write_log("DA: Can't understand direct access line:\n   %s\n",
			      line);
		    break;
		}
		mem=open("/dev/mem",O_RDWR);
		result=mmap((void*)(NATMEM_OFFSET+base),
			    1<<size,PROT_READ|PROT_WRITE,
			    MAP_SHARED,mem,nbase);
		if (result==(void*)-1) {
		    write_log("DA: Could not map %08x to %08x\n",
			    nbase,NATMEM_OFFSET+base);
		    abort();
		}
		close(mem);

		map_banks(&direct_mem_bank,base>>16,1<<(size-16),0);
		write_log("DA: Mapped native mem 0x%08x of size 0x%08x at 68k address 0x%08x\n",nbase,1<<size,base);
		break;
	     case 'n':
		if (sscanf(line+1,"%d=%d",&xint,&aint)!=2) {
		    write_log("DA: Can't understand direct access line:\n   %s\n",
			      line);
		    break;
		}
		if (xint>=NUM_XINT) {
		    write_log("DA: Sorry, can't handle x86 Interrupt %d\n",xint);
		    break;
		}
		if (aint>=NUM_AINT) {
		    write_log("DA: Sorry, can't handle Amiga Interrupt %d\n",xint);
		    break;
		}
		{
		    int fd;
		    char name[100];
		    struct sigaction sa;
		    int answer;

		    sprintf(name,"/dev/irq%d",xint);
		    fd=open(name,O_RDWR);
		    if (fd==-1) {
			write_log("DA: Could not open irq device %s\n",name);
			break;
		    }
		    
		    sigemptyset(&sa.sa_mask);
		    sa.sa_handler=x86_interrupt;
		    sa.sa_flags=SA_RESTART;
		    answer=sigaction(SIGBASE+xint, &sa, NULL);
		    if (answer!=0) {
			write_log("DA: Could not set signal handler %d\n",SIGBASE+xint);
			close(fd);
			break;
		    }
		    answer=irq_request(fd,SIGBASE+xint,IRQ_SHARED);
		    if (answer!=0) {
			write_log("DA: Failed to exclusively request IRQ %d\n",
				  xint);
			close(fd);
			break;
		    }
		    intnum[xint]=aint;
		    write_log("DA: Mapping x86 interrupt %2d to Amiga int %2d\n",xint,aint);
		}
		break;
	     default:
		write_log("DA: Can't understand direct access line:\n   %s\n",
			  line);
		break;
	    }
	}
    }
    fclose(conf);
    write_log("DA: Finished setting up direct access\n");
    return;
}

#else

static void direct_access_install(void)
{
}

static void direct_access_reset(void)
{
}

#endif



